( time and date functions require I2C and S-35390A libraries )

\ display the specified month as a three character string
: .month ( uMonth -- )
  ( mult month by 3 )
  DUP 2* +
  S" ???JanFebMarAprMayJunJulAugSepOctNovDec"
  DROP + #3 TYPE ;
  
\ display the specified day of week as a three character string
: .dow ( uDay -- )
  ( mult day by 3 )
  DUP 2* +
  S" MonTueWedThuFriSatSun???"
  DROP + #3 TYPE ;

( Routines to display date/time seperators )  

\ display a comma 
: ., [CHAR] , EMIT ;

\ display a colon
: .: [CHAR] : EMIT ;

( Routines to display numbers at a fixed width with leading zeros )

\ display a number in two digits with leading zeros
: .R2 S>D <# # # #> TYPE ;

\ display the date
: DATE. ( -- )
  DATE WEEKDAY .dow ., SPACE
  DATE ROT ROT SWAP 1 .R SPACE .month SPACE . ;
  
\ display the time in 24hr format
: TIME. ( -- )
  TIME 1 .R .: .R2 .: .R2 ;
  
\ display the date and time in internet format
: TIME&DATE. TIME. SPACE DATE. ;
