.( timer demo, uses a COG to keep time )

0 VALUE timer_cog

#16 QBYTES timer_data ( save space for three longs )

: timer_date
  timer_data #4 + ; 
  
: timer_lock
  timer_data #8 + ; 

: timer_ticks 
  timer_data #12 + ; 

LOCK-NEW S>D timer_lock Q! 

CLKFREQ #100. D/ timer_ticks Q!

: timer-lock ( -- ) 
  BEGIN 
    timer_lock Q@ D>S LOCK-SET
  UNTIL ; 
  
: timer-unlock ( -- )
  timer_lock Q@ D>S LOCK-CLR DROP ;

: set-time ( dBcdTime -- )
  timer-lock timer_data Q! timer-unlock ;

: set-date ( dBcdDate -- )
  timer-lock timer_date Q! timer-unlock ;

: set-datetime ( dBcdDate dBcdTime -- )
  timer-lock
  timer_data Q!
  timer_date Q!
  timer-unlock ;
  
: clr-time ( -- )
  0. 0. set-datetime ;

: bcdtimestr ( dBcdTime -- cadr uCount )
  \ save current numeric base and set to base 16 
  BASE @ >R HEX
  \ format value as BCD time with seperators
  <# # # $2E HOLD # # $3A HOLD # # $3A HOLD # # #> 
  \ restore save numeric base value
  R> BASE ! ;

: bcddatestr ( dBcdTime -- cadr uCount )
  \ save current numeric base and set to base 16 
  BASE @ >R HEX
  \ format value as BCD date with seperators
  <# # # $2F HOLD # # $2F HOLD # # # # #> 
  \ restore save numeric base value
  R> BASE ! ;
    
: time. ( -- ) 
  timer_data Q@ bcdtimestr TYPE ;

: date. ( -- ) 
  timer_date Q@ bcddatestr TYPE ;

\ This constant must reflect the block number 
\ used to store COG binary image.
#19 VALUE timer_block

: timer-start ( -- ) 
  timer_data timer_block COG-LOAD 
  TO timer_cog ;

