MARKER forget-tools

( SEE factor words )

: CFA>NFA ( cfa - 0 or NFA )
  DUP HERE < IF 
    LATEST @
    BEGIN 
      DUP 
    WHILE 
      2DUP >= IF
        NIP EXIT 
      ELSE 
        NFA>LFA @ 
      THEN 
    REPEAT
    2DROP 0 
  ELSE 
    DROP 0 
  THEN ;
  
: NATIVE? ( nfa - f ) 
  NFA>FFA @ 2 AND 0<> ;
  
: NATIVE>NFA ( xt - 0 or nfa )
  LATEST @ 
  BEGIN 
    DUP
  WHILE 
    DUP NATIVE? IF
      2DUP NFA>CFA @ = IF 
        NIP EXIT 
      THEN
    THEN 
    NFA>LFA @ 
  REPEAT 
  2DROP 0 ;

: byte. ( c -- ) DUP $10 U< IF $30 EMIT THEN U. ;

: word. ( u -- ) DUP $1000 U< IF $30 EMIT THEN
  DUP $100 U< IF $30 EMIT THEN DUP $10 U< IF $30 EMIT THEN U. ;

: xt.? ( xt - )
  DUP CFA>NFA ?DUP IF
    COUNT TYPE DROP TRUE
  ELSE
    NATIVE>NFA ?DUP IF 
      COUNT TYPE TRUE 
    ELSE 
      FALSE 
    THEN
  THEN ;
  
: xt. ( xt - )
  DUP xt.? IF
    DROP
  ELSE
    word.
  THEN ;

: xt-lit. ( u -- )
 DUP word. 
 xt.? DROP ;


( show word at a-adr1 as string, a-adr2 is next word address )

: xt-dis. ( a-adr1 -- a-adr2 ) DUP >R @ 
  CASE
    $07 OF 
      ." (nop)"
    ENDOF
    $08 OF
      ." (exit-adr)" 
    ENDOF  
    $0C OF 
        ." (exit)" 
    ENDOF
    $0E OF 
      ." (dliteral) " 
      R@ CELL+ 2@ UD. R> 2 CELLS + >R
    ENDOF
    $12 OF
      ." (adr-literal) " 
      R@ CELL+ @ xt-lit. R> CELL+ >R
    ENDOF
    $13 OF 
      ." (literal) " 
      R@ CELL+ @ xt-lit. 
      R> CELL+ >R 
    ENDOF
    $16 OF
      ." (0branch) " 
      R@ CELL+ @ xt-lit.
      R> CELL+ >R
    ENDOF
    $1C OF
      ." (branch) "
      R@ CELL+ @ xt-lit.
      R> CELL+ >R
    ENDOF
    $1E OF
      ." (loop) "
      R@ CELL+ @ word. R> CELL+ >R
    ENDOF
    $28 OF
      ." (+loop) "
      R@ CELL+ @ word. R> CELL+ >R
    ENDOF
    $38 OF 
      ." (s" $22 EMIT ." ) "
      R@ CELL+ COUNT 
      DUP 1+ ALIGNED R> + >R TYPE
    ENDOF
    $40 OF 
      ." (does) "
      R@ CELL+ @ xt-lit. R> CELL+ >R 
    ENDOF
    $48 OF 
      ." (execute)"
    ENDOF
  OTHERWISE
    DUP xt. 
  ENDCASE
  R> CELL+ ;

( DUMP/.S factor words )

: xtline. ( xt-adr1 -- xt-adr2 ) DUP word. SPACE xt-dis. CR ;

: hexline. ( c-adr u -- ) OVER + SWAP ?DO I C@ byte. LOOP ;

: asciiline. ( c-adr u -- ) OVER + SWAP ?DO I C@ DUP
  #32 #128 WITHIN IF EMIT ELSE DROP $2E EMIT THEN LOOP ;

: dump16 ( c-adr -- )
  DUP 16 hexline. 3 SPACES 16 asciiline. CR ;

: sempty? ( -- f ) SP@ S0 = ;

: sunder? ( -- f ) SP@ S0 U> ;

: typeword ( a-adr -- ) COUNT TYPE SPACE ;

: wordsize ( a-adr -- u ) COUNT NIP 1+ ;

: fitword. ( a-adr1 u1 u2 -- f ) ROT DUP >R wordsize + >=
  IF R@ typeword TRUE ELSE FALSE THEN R> DROP ;

: wordend ( nfa -- nfa2) 
  HERE 4 + >R 
  LATEST @
  BEGIN
    DUP
  WHILE
    2DUP < IF
      RDROP DUP >R
    THEN
    NFA>LFA @
  REPEAT
  2DROP R> NFA>LFA ;

( List the definition names in the word list )

: WORDS ( -- ) CR 0 LATEST @ BEGIN DUP WHILE 2DUP SWAP 72
  SWAP fitword. NOT IF CR NIP 0 SWAP 2DUP SWAP 72 SWAP fitword.
  DROP THEN DUP wordsize ROT + SWAP NFA>LFA @ REPEAT 2DROP CR ;

( Display representation of the named word definition. )

: SEE ' CR BASE @ >R HEX DUP wordend >R BEGIN DUP R@ <
  WHILE xtline. REPEAT RDROP DROP R> BASE ! ;

( Display u consecutive addresses values starting at c-adr )

: DUMP ( c-adr u -- ) BASE @ >R 16 BASE ! CR OVER + SWAP
  ?DO I DUP word. SPACE dump16 16 +LOOP R> BASE ! ;

( Display the value stored at a-adr )

: ? ( a-adr -- ) @ U. ;

( display the values currently on the data stack )

: .S ( -- ) 
  CR sempty? IF 
    ." Stack empty" 
  ELSE 
    sunder? IF
      ." Stack underflow "
      SP@ S0 - . 
    ELSE 
      SP@ 2- S0 2- ?DO
        I @ . -2 
      +LOOP 
    THEN
  THEN ;

( LOAD a sequence of blocks showing the block numbers as they are loaded )

: THRU. ( u1 u2 -- )
  ( 'Save the current input source state )
  ( LENGTH, SOURCE, IN, SOURCE-ID, BLK to return stack )
  2>R SAVE-INPUT 2R>
  1+ SWAP ?DO
    ( Display block number )
    I 4 .R
    ( LOAD the block )
    I (load)
    ( erase block number )
    4 BACKSPACES
  LOOP
  RESTORE-INPUT ;
  