( Output to VGA using defered words; EMIT, and EMIT? )

vga_cols CONSTANT vt_cols
vga_rows CONSTANT vt_rows
0 VALUE vt_col 
0 VALUE vt_row 
0 VALUE vt_colidx

\ Fake a text cursor

0    VALUE vt_curch
0    VALUE vt_oldch
0    VALUE vt_curadr
TRUE VALUE vt_curon

\ Draw the cursor on the screen
: vt-showcr ( uX uY -- )
  \ get cursor screen adr
  vga-adr
  ( uCurAdr )
  \ save adress of cursor char
  DUP TO vt_curadr
  \ save character at cursor
  DUP @ TO vt_oldch
  \ display cursor
  vt_curch SWAP ! ;

\ Remove the cursor from the screen if visible
: vt-hidecr ( -- )
  vt_curadr DUP IF
    0 TO vt_curadr
    vt_oldch SWAP !
  ELSE
    DROP
  THEN ;

\ Draw the cursor at the supplied X Y positions
: vt-crxy ( uX uY )
  vt-hidecr
  vt-showcr ;

\ Draw the cursor at the current X Y position
: vt-crcur ( -- )
  vt_curon IF
    vt_col vt_row vt-crxy
  THEN ;

\ Set the cursor on or off    
: vt-cursor ( fShow -- )
  DUP TO vt_curon
  IF
    vt-crcur
  ELSE
    vt-hidecr
  THEN ;

\ Terminal erase functions

: vt-cln ( uRow - ) 
  vt-hidecr
  vt_colidx SWAP vga-cln
  vt-crcur ;

: vt-cls ( -- )
  vt-hidecr
  vt_colidx vga-cls 0 TO vt_row 0 TO vt_col
  vt-crcur ;

: vt-clr-eol 
  vt-hidecr
  vga_cols vt_col ?DO
    I vt_row vt_colidx BL vga-out
  LOOP 
  vt-crcur ; 
  
: vt-clr-eos
  vt-clr-eol 
  vga_rows vt_row 1+ ?DO
    I vt-cln 
  LOOP ;

: vt-scrup 
  vt-hidecr
  vga_screen DUP vga_cols CELLS + SWAP
  vga_screensize vga_cols - CELLS MOVE
  vga_rows 1- vt-cln ;
  
\ Terminal Character Output Functions

: vt-color ( uColorIdx -- )
  #7 AND DUP
  TO vt_colidx
  #95 vga-enc TO vt_curch ;
  
: vt-color@ ( -- uColorIdx )
  vt_colidx ;
  
  : vt-cr ( -- ) 
  0 TO vt_col 
  vt_row 1+ vga_rows MOD DUP TO vt_row
  0= IF
    vt-scrup vga_rows 1- TO vt_row
  THEN
  vt-crcur ;
  
: vt-cntrl ( c -- ) 
  DUP $0D = IF 
    DROP vt-cr 
  ELSE 
    $08 = vt_col 0> AND IF
      vt-hidecr
      vt_col 1- TO vt_col
      vt_col vt_row vt_colidx BL vga-out
      vt-crcur
    THEN 
  THEN ;

: vt-emit? ( -- f )
  TRUE ;

: vt-emit ( cChar - )
  DUP #32 < IF 
    vt-cntrl 
  ELSE
    vt-hidecr 
    vt_col vt_row
    ROT vt_colidx SWAP vga-out 
    vt_col 1+ vga_cols MOD DUP TO vt_col 
    0= IF 
      vt-cr
    ELSE
      vt-crcur
    THEN
  THEN ;   

\ Terminal cursor position functions

\ Sets the terminal display current column and row
: vt-xy ( uX uY - ) vga_rows MOD TO vt_row
  vt_cols MOD TO vt_col
  vt-crcur ;

\ Returns the terminal display current column and row
: vt-xy@ ( -- uX uY )
  vt_col vt_row ;

\ Returns the number of columns and rows on the display
: vt-max-xy ( -- uX uY ) 
  vt_cols vt_rows ;

\ Hook the forth character output and terminal words to the video terminal 
: vt>term ( -- )
  ( Set defered console words EMIT and EMIT? to use VGA )
  ['] vt-emit IS EMIT 
  ['] vt-emit? IS EMIT?
  ( Set defered terminal words to use VGA )
  ['] vt-cls IS PAGE 
  ['] vt-cursor IS CURSOR 
  ['] vt-xy IS AT-XY
  ['] vt-xy@ IS XY 
  ['] vt-max-xy IS MAX-XY 
  ['] vt-clr-eol IS CLR-EOL ;

\ set the color to index 0 and clear the terminal
0 vt-color vt-cls

